=begin
(c) TIG 2009

  export_by_layer.rb
  
Usage: export_by_layer(type)
Exports everything in the active Model into a set of files 'by layer', 
the argument 'type' sets the file export type...
Faces with Edges on another layer take those Edges with them...
e.g. export_by_layer('obj')

### load"export_by_layer.rb"

=end
require 'sketchup.rb'
def export_by_layer(type)
  model=Sketchup.active_model
  entities=model.active_entities
  defns=model.definitions
  clayer=model.active_layer
  model.active_layer=nil
  dlayer=model.active_layer
  model.active_layer=clayer
  layers=model.layers
  ###layers=layers.to_a-[dlayer]###ignore default layer
  modelpath=File.dirname(model.path)
  modeltitle=model.title
  if modelpath==""
    puts "Model has not been saved..."
    return nil
  end#if
  count=0
  layers.each{|layer|
    model.start_operation("Export by Layer")
    entities.each{|e|
      if e.valid? and e.layer !=layer
        if e.class==Sketchup::Edge
          faceless=true
          e.faces.each{|f|
            if f.layer==layer
              faceless=false
              ### keep edge NOT on layer if its face is on layer
              break
            end#if
          }
          e.erase! if faceless
        else
          e.erase!
        end#if
      end#if
    }
    defns.each{|defn|
     defn.entities.each{|e|
      if e.valid? and not e.layer==nil and e.layer !=layer
        if e.class==Sketchup::Edge
          faceless=true
          e.faces.each{|f|
            if f.layer==layer
              faceless=false
              ### keep edge NOT on layer if its face is on layer
              break
            end#if
          }
          e.erase! if faceless
        else
          e.erase!
        end#if
      end#if
     }
    }
    layername=layer.name.gsub(/[^_a-zA-Z0-9]/,'_')
    model.export(modelpath+"/"+modeltitle+"__Layer_"+layername+"."+type,false)### exporter
    count+=1
    model.commit_operation
    Sketchup.undo ### undeletes stuff ?
  }#end layer
  puts count.to_s+" files exported by layer, as '"+type+"'"
  
end#def
###